# WARNING: Please don't edit this file. It was generated by Python/WinRT v3.0.0

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property
from abc import abstractmethod

import winrt._winrt
import winrt.system
import winrt.windows.applicationmodel as windows_applicationmodel
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections
import winrt.windows.storage as windows_storage

from winrt.windows.gaming.preview.gamesenumeration import GameListCategory, GameListEntryLaunchableState
from winrt.windows.gaming.preview.gamesenumeration import GameListChangedEventHandler, GameListRemovedEventHandler

Self = typing.TypeVar('Self')

@typing.final
class GameList_Static(winrt._winrt.IInspectable_Static):
    # Windows.Foundation.IAsyncOperation`1<Windows.Foundation.Collections.IVectorView`1<Windows.Gaming.Preview.GamesEnumeration.GameListEntry>> Windows.Gaming.Preview.GamesEnumeration.GameList::FindAllAsync()
    def find_all_async(cls) -> windows_foundation.IAsyncOperation[typing.Sequence[GameListEntry]]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Foundation.Collections.IVectorView`1<Windows.Gaming.Preview.GamesEnumeration.GameListEntry>> Windows.Gaming.Preview.GamesEnumeration.GameList::FindAllAsync(System.String)
    def find_all_async_package_family_name(cls, package_family_name: str, /) -> windows_foundation.IAsyncOperation[typing.Sequence[GameListEntry]]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Gaming.Preview.GamesEnumeration.GameListEntry> Windows.Gaming.Preview.GamesEnumeration.GameList::MergeEntriesAsync(Windows.Gaming.Preview.GamesEnumeration.GameListEntry,Windows.Gaming.Preview.GamesEnumeration.GameListEntry)
    def merge_entries_async(cls, left: GameListEntry, right: GameListEntry, /) -> windows_foundation.IAsyncOperation[GameListEntry]: ...
    # Windows.Foundation.IAsyncOperation`1<Windows.Foundation.Collections.IVectorView`1<Windows.Gaming.Preview.GamesEnumeration.GameListEntry>> Windows.Gaming.Preview.GamesEnumeration.GameList::UnmergeEntryAsync(Windows.Gaming.Preview.GamesEnumeration.GameListEntry)
    def unmerge_entry_async(cls, merged_entry: GameListEntry, /) -> windows_foundation.IAsyncOperation[typing.Sequence[GameListEntry]]: ...
    # Windows.Foundation.EventRegistrationToken Windows.Gaming.Preview.GamesEnumeration.GameList::add_GameAdded(Windows.Gaming.Preview.GamesEnumeration.GameListChangedEventHandler)
    def add_game_added(cls, handler: GameListChangedEventHandler, /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameList::remove_GameAdded(Windows.Foundation.EventRegistrationToken)
    def remove_game_added(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.EventRegistrationToken Windows.Gaming.Preview.GamesEnumeration.GameList::add_GameRemoved(Windows.Gaming.Preview.GamesEnumeration.GameListRemovedEventHandler)
    def add_game_removed(cls, handler: GameListRemovedEventHandler, /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameList::remove_GameRemoved(Windows.Foundation.EventRegistrationToken)
    def remove_game_removed(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.EventRegistrationToken Windows.Gaming.Preview.GamesEnumeration.GameList::add_GameUpdated(Windows.Gaming.Preview.GamesEnumeration.GameListChangedEventHandler)
    def add_game_updated(cls, handler: GameListChangedEventHandler, /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameList::remove_GameUpdated(Windows.Foundation.EventRegistrationToken)
    def remove_game_updated(cls, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...

@typing.final
class GameList(winrt.system.Object, metaclass=GameList_Static):
    pass

@typing.final
class GameListEntry(winrt.system.Object, IGameListEntry):
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Gaming.Preview.GamesEnumeration.GameListEntry::LaunchAsync()
    def launch_async(self) -> windows_foundation.IAsyncOperation[bool]: ...
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.GameListEntry::SetCategoryAsync(Windows.Gaming.Preview.GamesEnumeration.GameListCategory)
    def set_category_async(self, value: GameListCategory, /) -> windows_foundation.IAsyncAction: ...
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.GameListEntry::SetLauncherExecutableFileAsync(Windows.Storage.IStorageFile)
    def set_launcher_executable_file_async(self, executable_file: windows_storage.IStorageFile, /) -> windows_foundation.IAsyncAction: ...
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.GameListEntry::SetLauncherExecutableFileAsync(Windows.Storage.IStorageFile,System.String)
    def set_launcher_executable_file_with_params_async(self, executable_file: windows_storage.IStorageFile, launch_params: str, /) -> windows_foundation.IAsyncAction: ...
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.GameListEntry::SetTitleIdAsync(System.String)
    def set_title_id_async(self, id: str, /) -> windows_foundation.IAsyncAction: ...
    # Windows.Gaming.Preview.GamesEnumeration.GameListCategory Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_Category()
    @_property
    def category(self) -> GameListCategory: ...
    # Windows.ApplicationModel.AppDisplayInfo Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_DisplayInfo()
    @_property
    def display_info(self) -> windows_applicationmodel.AppDisplayInfo: ...
    # Windows.Foundation.Collections.IMapView`2<System.String,System.Object> Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_Properties()
    @_property
    def properties(self) -> typing.Mapping[str, winrt.system.Object]: ...
    # Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_GameModeConfiguration()
    @_property
    def game_mode_configuration(self) -> GameModeConfiguration: ...
    # System.String Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_LaunchParameters()
    @_property
    def launch_parameters(self) -> str: ...
    # Windows.Gaming.Preview.GamesEnumeration.GameListEntryLaunchableState Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_LaunchableState()
    @_property
    def launchable_state(self) -> GameListEntryLaunchableState: ...
    # Windows.Storage.IStorageFile Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_LauncherExecutable()
    @_property
    def launcher_executable(self) -> windows_storage.IStorageFile: ...
    # System.String Windows.Gaming.Preview.GamesEnumeration.GameListEntry::get_TitleId()
    @_property
    def title_id(self) -> str: ...

@typing.final
class GameModeConfiguration(winrt.system.Object):
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::SaveAsync()
    def save_async(self) -> windows_foundation.IAsyncAction: ...
    # Windows.Foundation.IReference`1<System.Int32> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_PercentGpuTimeAllocatedToGame()
    @_property
    def percent_gpu_time_allocated_to_game(self) -> typing.Optional[winrt.system.Int32]: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_PercentGpuTimeAllocatedToGame(Windows.Foundation.IReference`1<System.Int32>)
    @percent_gpu_time_allocated_to_game.setter
    def percent_gpu_time_allocated_to_game(self, value: typing.Optional[winrt.system.Int32]) -> None: ...
    # Windows.Foundation.IReference`1<System.Int32> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_PercentGpuMemoryAllocatedToSystemCompositor()
    @_property
    def percent_gpu_memory_allocated_to_system_compositor(self) -> typing.Optional[winrt.system.Int32]: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_PercentGpuMemoryAllocatedToSystemCompositor(Windows.Foundation.IReference`1<System.Int32>)
    @percent_gpu_memory_allocated_to_system_compositor.setter
    def percent_gpu_memory_allocated_to_system_compositor(self, value: typing.Optional[winrt.system.Int32]) -> None: ...
    # Windows.Foundation.IReference`1<System.Int32> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_PercentGpuMemoryAllocatedToGame()
    @_property
    def percent_gpu_memory_allocated_to_game(self) -> typing.Optional[winrt.system.Int32]: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_PercentGpuMemoryAllocatedToGame(Windows.Foundation.IReference`1<System.Int32>)
    @percent_gpu_memory_allocated_to_game.setter
    def percent_gpu_memory_allocated_to_game(self, value: typing.Optional[winrt.system.Int32]) -> None: ...
    # Windows.Foundation.IReference`1<System.Int32> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_MaxCpuCount()
    @_property
    def max_cpu_count(self) -> typing.Optional[winrt.system.Int32]: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_MaxCpuCount(Windows.Foundation.IReference`1<System.Int32>)
    @max_cpu_count.setter
    def max_cpu_count(self, value: typing.Optional[winrt.system.Int32]) -> None: ...
    # System.Boolean Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_IsEnabled()
    @_property
    def is_enabled(self) -> bool: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_IsEnabled(System.Boolean)
    @is_enabled.setter
    def is_enabled(self, value: bool) -> None: ...
    # Windows.Foundation.IReference`1<System.Int32> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_CpuExclusivityMaskLow()
    @_property
    def cpu_exclusivity_mask_low(self) -> typing.Optional[winrt.system.Int32]: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_CpuExclusivityMaskLow(Windows.Foundation.IReference`1<System.Int32>)
    @cpu_exclusivity_mask_low.setter
    def cpu_exclusivity_mask_low(self, value: typing.Optional[winrt.system.Int32]) -> None: ...
    # Windows.Foundation.IReference`1<System.Int32> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_CpuExclusivityMaskHigh()
    @_property
    def cpu_exclusivity_mask_high(self) -> typing.Optional[winrt.system.Int32]: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_CpuExclusivityMaskHigh(Windows.Foundation.IReference`1<System.Int32>)
    @cpu_exclusivity_mask_high.setter
    def cpu_exclusivity_mask_high(self, value: typing.Optional[winrt.system.Int32]) -> None: ...
    # System.Boolean Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_AffinitizeToExclusiveCpus()
    @_property
    def affinitize_to_exclusive_cpus(self) -> bool: ...
    # System.Void Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::put_AffinitizeToExclusiveCpus(System.Boolean)
    @affinitize_to_exclusive_cpus.setter
    def affinitize_to_exclusive_cpus(self, value: bool) -> None: ...
    # Windows.Foundation.Collections.IVector`1<System.String> Windows.Gaming.Preview.GamesEnumeration.GameModeConfiguration::get_RelatedProcessNames()
    @_property
    def related_process_names(self) -> typing.MutableSequence[str]: ...

@typing.final
class GameModeUserConfiguration_Static(winrt._winrt.IInspectable_Static):
    # Windows.Gaming.Preview.GamesEnumeration.GameModeUserConfiguration Windows.Gaming.Preview.GamesEnumeration.GameModeUserConfiguration::GetDefault()
    def get_default(cls) -> GameModeUserConfiguration: ...

@typing.final
class GameModeUserConfiguration(winrt.system.Object, metaclass=GameModeUserConfiguration_Static):
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.GameModeUserConfiguration::SaveAsync()
    def save_async(self) -> windows_foundation.IAsyncAction: ...
    # Windows.Foundation.Collections.IVector`1<System.String> Windows.Gaming.Preview.GamesEnumeration.GameModeUserConfiguration::get_GamingRelatedProcessNames()
    @_property
    def gaming_related_process_names(self) -> typing.MutableSequence[str]: ...

@typing.final
class _IGameListEntry: ...

class IGameListEntry(winrt._winrt.IInspectable):
    # Windows.Foundation.IAsyncOperation`1<System.Boolean> Windows.Gaming.Preview.GamesEnumeration.IGameListEntry::LaunchAsync()
    @abstractmethod
    def launch_async(self) -> windows_foundation.IAsyncOperation[bool]: ...
    # Windows.Foundation.IAsyncAction Windows.Gaming.Preview.GamesEnumeration.IGameListEntry::SetCategoryAsync(Windows.Gaming.Preview.GamesEnumeration.GameListCategory)
    @abstractmethod
    def set_category_async(self, value: GameListCategory, /) -> windows_foundation.IAsyncAction: ...
    # Windows.Gaming.Preview.GamesEnumeration.GameListCategory Windows.Gaming.Preview.GamesEnumeration.IGameListEntry::get_Category()
    @_property
    @abstractmethod
    def category(self) -> GameListCategory: ...
    # Windows.ApplicationModel.AppDisplayInfo Windows.Gaming.Preview.GamesEnumeration.IGameListEntry::get_DisplayInfo()
    @_property
    @abstractmethod
    def display_info(self) -> windows_applicationmodel.AppDisplayInfo: ...
    # Windows.Foundation.Collections.IMapView`2<System.String,System.Object> Windows.Gaming.Preview.GamesEnumeration.IGameListEntry::get_Properties()
    @_property
    @abstractmethod
    def properties(self) -> typing.Mapping[str, winrt.system.Object]: ...

